<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <title>WebGL Demo</title>
</head>
<body>
<div id="loading"></div>
<canvas id="canvas" width="640" height="480"></canvas>
<br/><button onclick="screenshot()">Screenshot</button>
<button onclick="save_transform()">Save Transform</button>

<script type="module">
import {downloader, Downloader} from "./src/downloader.js";
import {PresentationScene, GlScene} from "./src/scene.js";
import {RenderPipeline, pipebuf} from "./src/rendering.js";
import {box, sphere} from "./src/shapes.js";
import {ObjLoader} from "./src/load_obj.js";
import {Model} from "./src/drawable.js";
import {Color, Point3D, Point2D} from "./src/math.js";
import {Prelin, simple_prng, MultiPrelin, Voronoi, noise_presets, NoiseToColorGradient} from "./src/noise.js";


var loading_elem = document.getElementById("loading");
downloader.on_update = function(job)
{
    var act = "";
    if ( job.status == Downloader.Status.ADDED )
        act = "queued";
    else if ( job.status == Downloader.Status.LOAD_START )
        act = "downloaded";
    else if ( job.status == Downloader.Status.LOAD_END )
        act = "processed";
    else
        act = "waiting";

    var msg = `loading: ${(job.downloader.progress * 100).toFixed(1)}% - ${act} ${job.uri}`;
    if ( job.downloader.progress >= 1.0 )
    {
        msg = "";
    }
    loading_elem.textContent = msg;
};

var canvas = document.querySelector('#canvas');
var scene = PresentationScene.from_canvas(canvas);
var post_scene = GlScene.linked(scene);
post_scene.objects.push(sphere(1.3, 12, 12));
post_scene.render_options["bg_color"] = new Color(0, 0, 0, 0);

var renderer = ((new RenderPipeline(scene.gl))
// fetch depth
//     .default_renderer()
//     .new_framebuffer(0, true, true)
// normal render
    .lighting()
    .default_renderer()
// render to new_framebuffer, multisampling for anti aliasing
//     .framebuffer_multisample(1)
//     .blit(1, true, true)
//     .postprocess()
// show depth
//     .new_framebuffer(1, true, true)
//     .blit(1, true, true)
//     .postprocess("depth.glsl", {z_near: 0.1, z_far: 100}, pipebuf(-1, 1))
// misc post effects
//     .post_effect("invert.glsl")
//     .kernel_effect(...KernelRenderer.presets.edge_detect)
//     .kernel_effect(...KernelRenderer.presets.gaussian5)
//     .kernel_effect(...KernelRenderer.presets.sharpen)
//     .post_effect("pixelate.glsl", {pixel_size: 5}).named("pixelate")
//     .dynamic_property(
//         "pixelate",
//         function(){ return this.named_steps.pixelate.uniform.pixel_size; },
//         function(v){ this.named_steps.pixelate.uniform.pixel_size = v; },
//     )
//     .new_framebuffer(1, true, true)
// directional gaussian blur
//     .new_framebuffer(1)
//     .blur([1, 0], 10)
//     .new_framebuffer(1)
//     .blur([0, 1], 10)
// x-ray scene
//     .alt_scene(post_scene, new RenderPipeline(post_scene.gl)
//         .default_renderer({enable_depth: true, clear_depth:true, clear_color: false})
//     )
// bloom
//     .new_framebuffer(6)
//     .blit(6).named("buffers")
//     .blur([1, 0], 10, {}, pipebuf("buffers", 3)).named("blur_h")
//     .new_framebuffer(1, false, false, new Color(0,0,0,1))
//     .blur([0, 1], 10, {}).named("blur_v")
//     .new_framebuffer(1, false, false)
//     .postprocess("combine_fragment.glsl", {samplers_used: 2},
//         pipebuf()
//         .p("buffers", 3, "sampler.0.sampler")
//         .p(-1, 0, "sampler.1.sampler")
//     )
//     .new_framebuffer(1, false, false).named("bloom")
//     .postprocess("combine_fragment.glsl", {samplers_used: 4},
//         pipebuf()
//         .p("buffers", 2, "sampler.0.sampler")
//         .p("bloom",   0, "sampler.1.sampler")
//         .p("buffers", 4, "sampler.2.sampler")
//         .p("buffers", 5, "sampler.3.sampler")
//     )
//     .dynamic_property(
//         "bloom_radius",
//         function(){ return this.named_steps.blur_h.radius; },
//         function(v)
//         {
//             this.named_steps.blur_h.radius = v;
//             this.named_steps.blur_v.radius = v;
//         },
//     )
// deferred lighting

);
// scene.load_texture("doughnut", "assets/doughnut.png");
// scene.load_video_texture("doughnut", "assets/animated.mp4");
// scene.load_texture("globe", "assets/globe.jpeg");
// scene.load_texture("woods", "assets/woods.png");
scene.environment.from_uri("assets/woods.png");
// scene.environment.from_cubemap_uris(
//     "assets/cube/+x.png",
//     "assets/cube/-x.png",
//     "assets/cube/+y.png",
//     "assets/cube/-y.png",
//     "assets/cube/+z.png",
//     "assets/cube/-z.png"
// );

var cubemap = box(40);
cubemap.material.environment = true;
scene.objects.push(cubemap);

var cube = box(2);
// var cube = sphere(2, 12, 12);
scene.objects.push(cube);
// cube.material.displace_mode = Material.DisplaceMode.NORMAL;
// cube.material.displace_map = scene.load_texture("bump", "assets/globe-bump.jpg");
// cube.material.displace_map = scene.load_texture("normal", "assets/normal.jpg");
// cube.material.diffuse_texture = cube.material.displace_map;
// cube.material.diffuse_texture = scene.load_texture("globe", "assets/globe.jpeg");
// cube.material.diffuse_texture = scene.load_video_texture("doughnut", "assets/animated.mp4");
// cube.material.specular = new Color(0, 0, 0);
// cube.material.metallic = 1;
// cube.material.fresnel.r = 1;
// scene.shader.load_extension("WEBGL_draw_buffers", "GL_EXT_draw_buffers");
// cube.material.emissive = new Color(1, 1, 1);
// cube.material.diffuse_texture = new Texture(scene.gl);
// cube.material.diffuse_texture.create_raw(fb.frame_buffer.width, fb.frame_buffer.height, null);
// cube.material.diffuse_texture = fb.frame_buffer.buffers[1];
// var noise = new Prelin(5, 1, simple_prng());
// var noise1 = ((new MultiPrelin(simple_prng()))
//     .octave(1, 1).octave(5, 0.2).octave(10, 0.1)
// );
// procedural textures
/*// var noise = new Voronoi(1, 1, Math.hypot, simple_prng());
var noise = noise_presets.marble(simple_prng());
var lava = new NoiseToColorGradient([new Color(1, 1, 1), new Color(1, 1, 0), new Color(1, 0, 0)], .7, .7);
window.noise = noise;
cube.material.diffuse = new Color(0,0,0,1);
cube.material.specular = new Color(0,0,0,1);
cube.material.emissive = new Color(1,1,1,1);
cube.material.emissive_texture = noise.generate_texture_rgba(
    new Point2D(0, 0),
    new Point2D(1, 1),
    scene.gl,
    512,
    512,
    lava.to_color
//     (x => Math.abs(x-0.5) * 2 * 255)
//     (x => Math.abs(x) > 0.05 ? 0 : 255 )
//     (x => (x * 2 + 1) * 255 )
);*/

var marker = new Model();
scene.objects.push(marker);

var obj = new ObjLoader(scene);
obj.load_obj("assets/model.obj");
scene.objects.push(obj);


var square_rotation = 0.0;
var rotations_per_second = 0.25;

scene.on_frame = function(scene, frame_time)
{
//     scene.render_frame(fb);
//     fb.frame_buffer.copy_to_texture(cube.material.diffuse_texture, 1);

    square_rotation += frame_time * 0.001 * 2 * Math.PI * rotations_per_second;
//     square_rotation = Math.PI/2;
    obj.transform.clear();
    obj.transform.translate(new Point3D(0, -2, 0));
    obj.transform.rotate(Math.PI/12, new Point3D(1, 0, 0));
//     obj.transform.rotate(Math.sin(square_rotation) * Math.PI / 12, new Point3D(1, 0, 0));
    cube.transform.clear();
//     cube.transform.rotate(square_rotation, new Point3D(0, 1, 0));
    cube.transform.rotate(Math.PI / 4, new Point3D(0, 1, 0));
};

canvas.addEventListener("dblclick", function(ev)
{
    var ray = scene.reverse_project_ray(new Point2D(ev.offsetX, ev.offsetY));
//     marker.points[0].point = ray[0];
//     marker.points[1].point = ray[1];

    var intersect = ray.intersect_sphere(new Point3D(0, 0, 0), 2);
    console.log(intersect);
    if ( intersect )
    {
        marker.push_line([ray.start, intersect], Material.shadeless(new Color(0, 1, 1)));
        marker.push_points([intersect], Material.shadeless(new Color(1, 0, 0)));
    }
});

function load_transform()
{
    var url = new URL(window.location);
    for ( var c of ["x", "y", "z"] )
    {
        var p = url.searchParams.get("angles." + c);
        if ( p !== null )
            scene.angles[c] = Number(p);
    }
    var distance = url.searchParams.get("distance");
    if ( distance !== null )
        scene.distance = Number(distance);
}

scene.render_options.bg_color.a = 0;
// cube.transform.translate(new Point3D(0, 2, -20));
// scene.lights[0].type = Light.Type.POINT;
load_transform();
scene.render_start(renderer);

// make some stuff public
window.scene = scene;
window.renderer = renderer;
window.obj = obj;
window.cube = cube;
window.Color = Color;
</script>
<script>
function make_glass(material)
{
    material.index_of_refraction = 10;
    material.opacity = 0;
}

function screenshot()
{
  var win = window.open(canvas.toDataURL(), '_blank');
  win.focus();
}

function save_transform()
{
    var url = new URL(window.location);
    url.searchParams.set("distance", scene.distance);
    url.searchParams.set("angles.x", scene.angles.x);
    url.searchParams.set("angles.y", scene.angles.y);
    url.searchParams.set("angles.z", scene.angles.z);
    window.history.pushState(null, "", url);
}

function load_transform()
{
    var url = new URL(window.location);
    for ( var c of ["x", "y", "z"] )
    {
        var p = url.searchParams.get("angles." + c);
        if ( p !== null )
            scene.angles[c] = Number(p);
    }
    var distance = url.searchParams.get("distance");
    if ( distance !== null )
        scene.distance = Number(distance);
}

</script>
</body>
